# -*- coding: utf-8 -*-
#
#   Copyright 2009 Andrew Wilkinson <andrewjwilkinson@gmail.com>
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

import couchdb

from query import Query

class Cursor(object):
    def __init__(self, db):
        assert isinstance(db, couchdb.Database)

        self.db = db
        self.query = None
        self.results = None

    def execute(self, sql, params=(), temporary=False):
        self.query = Query(sql)
        self.results = self.query.run_query(self.db, params, temporary=temporary)

    def fetchall(self):
        return [r.doc for r in self.results]

    def fetchone(self):
        return None
